QtEvaluatorMorph.subclass("LauncherMorph", {	
	initialize: function($super,rect) {
        $super(rect);	
		 
        var bounds = this.rect();
        var inset = this.inset;
		
		this.removeMorph(this.textEditor);
		this.textEditor=null;
		
		this.list = new QListWidget();		
		var width=bounds.width()-inset*2;
		var height=bounds.height() * 0.75 - inset;
		this.textEditor = new QtProxyMorph(this.list, qrect(0, 0, width,height), 0);
		this.textEditor.allowsManipulation(false);;
		this.textEditor.moveTo(inset, inset);
		this.addMorph(this.textEditor);
	}
});

LauncherMorph.subclass("UserLauncherMorph", {	
	initialize: function($super,rect) {
        $super(rect);	
		this.pushButton.inner.text="Show user";
        this.pushButton.inner.pressed.connect(this, this.launch);		
		this.getFriends();
	},

	//gets friends from server
	getFriends:function(){
/*		var url = 'http://lively.cs.tut.fi:8010/channel'; 
		var accessManager = new QNetworkAccessManager(this);
		accessManager["finished(QNetworkReply*)"].connect(this, this.populateFriendList);
		accessManager.post(new QNetworkRequest(new QUrl(url)));	
	*/
		var url = 'http://lively.cs.tut.fi:8010/Account/'; 
		var accessManager = new QNetworkAccessManager(this);
		accessManager["finished(QNetworkReply*)"].connect(this, this.populateFriendList);
		accessManager.get(new QNetworkRequest(new QUrl(url)));
	},
	
	//callpackfunction for getFriends
	populateFriendList:function(reply){
		this.list.clear();
		var array=QPersevereAccessManager.parseReply(reply);		
		for (var i = 0; i < array.length; i ++){
			var username=array[i].username;
			if (username!==QtLogin.userName){
				this.list.addItem(array[i].username);
			}
		}
	},
	
	//launches 
	launch: function(foo) {
		var item = this.list.currentItem();
		if (item!==null){
			var friendName=item.text();
			var userman = new QtUserMan(friendName);

			var ellipse = new QtEllipseMorph(qrect(0,0, 50, 50));		
			ellipse.fillColor=appman.homeGradient;
			userman.setDefaults(ellipse);
			ellipse.allowsManipulation(true);
			ellipse.addMorph(userman);
//			world.addMorph(userman);
			userman.ellipse=ellipse;
			that = QtWorldMorph.current().addMorph(ellipse);	
			
			var lastMouseDown = QtEvents.lastMouseDownPos;
			that.setPos(lastMouseDown);			
		}
    }

});

LauncherMorph.subclass("AppLauncherMorph", {	
	initialize: function($super,rect) {
        $super(rect);	

		//populates application list
		this.list.addItem("Rectangle");
		this.list.addItem("Ellipse");
		this.list.addItem("ClassBrowser");
		this.list.addItem("Inspector");
		this.list.addItem("Editor");
		this.list.addItem("Debugger");
		this.list.addItem("QCalendarWidget");
		this.list.addItem("QCheckBox");
		this.list.addItem("QColorDialog");
		this.list.addItem("QComboBox");
		this.list.addItem("QDateTimeEdit");
		this.list.addItem("QDial");
		this.list.addItem("QLabel (QImage)");
		this.list.addItem("QLineEdit");
		this.list.addItem("QProgressBar");
		this.list.addItem("QPushButton");
		this.list.addItem("QScrollBar");
		this.list.addItem("QSlider");
		this.list.addItem("QSpinBox");
		this.list.addItem("QTextEdit");
		this.list.addItem("QWebViewCNN");
		this.list.addItem("QWebViewLively");
		this.list.addItem("Asteroids");
		this.list.addItem("Weather");
		this.list.addItem("Clock");
		this.list.addItem("Flickr");
		this.list.addItem("Comics");
		this.list.addItem("WeatherCameras");
		this.list.addItem("Map");
		this.list.addItem("MapNews");
		this.list.addItem("RSS");
		this.list.addItem("ScrapBook");
		this.list.addItem("WebcamMap");

		this.pushButton.inner.text="Launch application";
        this.pushButton.inner.pressed.connect(this, this.launch);		
	},
	//launches selected applicaiton
	launch: function(foo) {
		var item = this.list.currentItem();
		this.pushButton.inner.text=item.text();
		eval("QtEvents.new" + item.text() + "();");
		that.setPos(QtEvents.lastMouseDownPos);			
    }

});


QtMorph.subclass("QtAppMan", {

    documentation: "a QtAppManMorph",

	//morphs
	home: null,
	homeButton: null,
	appButton:null,
	usersButton:null,
	dockPad:null,
	launchPad:null,
	dockPadItemList:[],
	
	appLauncherMorph:null,
	userLauncherMorph:null,
	
	//variables
	distFromBorder: 10,
	homeSize: 114,
	borderWidth: 0,
	borderColor: QtColor.gray,
	fillColor:	null,
	opacity: 1,
	padsVisible: false,
	useDockPad: true,
	
	//dockpadvariables
	spinBox:null,
	maxItemNumber:5,
	spinBoxValue:0,
	
	//creates icons
	homeButtonIcon: new QIcon("images/appman/Home.png"),		
	homeButtonDownIcon: new QIcon("images/appman/Home_down.png"),
	plusIcon: new QIcon("images/appman/Plus.png"),
	plusDownIcon: new QIcon("images/appman/Plus_down.png"),
	restartIcon: new QIcon("images/appman/Restart.png"),
	restartDownIcon: new QIcon("images/appman/Restart_down.png"),
	usersIcon: new QIcon("images/appman/Users.png"),
	usersDownIcon: new QIcon("images/appman/Users_down.png"),
	
	initialize: function($super) {
		if (QtAppMan.appMan===null){
			$super();		 
			this.fillColor=this.homeGradient;
			//creates home button
			this.buildHome();
			QtAppMan.appMan=this;
			return this;
		}else{return QtAppMan.appMan}
    },
	
	buildHome: function(){
		//builds home button
		var homeButtonBorder = 2;
		var dist=this.distFromBorder-homeButtonBorder;
		var size=this.homeSize+2*homeButtonBorder;
		
        this.home = new QGraphicsEllipseItem(dist,dist, size, size, null);
		this.setPeer(this.home);
		this.setOpacity(this.opacity);

		var homeButton=new QPushButton();
		
		//sets sizes
		homeButton.setFixedSize(this.homeSize,this.homeSize);
		homeButton.setIconSize(new QSize(this.homeSize,this.homeSize));
		
		//sets pictures
		homeButton.icon = this.homeButtonIcon;
		
		//masks rectangle to cirle
		var mask = new QBitmap(new QPixmap("images/appman/mask.png").scaledToHeight(this.homeSize));
		homeButton.setMask(mask);

		homeButton.pressed.connect(this, this.homePressed);
		homeButton.released.connect(this, this.homeReleased);
		
		//sets proxy morphs
		var rect = qrect(this.distFromBorder, this.distFromBorder, this.homeSize, this.homeSize);
		this.homeButton = new QtProxyMorph(homeButton, rect);
        
		//sets proxymorphvariables
		this.homeButton.setBorderWidth(0);
		this.homeButton.setFillColor(QtColor.transparent);
		this.homeButton.allowsManipulation(false);

		
		//adds buttons to launchpad
		this.addMorph(this.homeButton);
		this.homeButton.moveTo(this.distFromBorder,this.distFromBorder);		
	
		if (this.padsVisible){
			this.showPads();
		}

		return;
	},
	
	//builds launch pad for launching new applications and friend panels
	homePressed: function() {
		//sets homebuttonicon
		this.homeButton.inner.icon=this.homeButtonDownIcon;
	},

		//changes icon back to normal after button has been released
	homeReleased: function() {
		//if pads are visible
		if (this.padsVisible){
			//then they are removed
			if (this.useDockPad){this.removeDockPad();}
			this.removeMorph(this.launchPad);
			this.padsVisible = false;
		}else{
			this.showPads();
		}
		//sets homebuttonicon
		this.homeButton.inner.icon=this.homeButtonIcon;
	},
	
	showPads: function(){
		//if pads are hidden, then they are shown
		//launchpad
		//this.buildLaunchPad();
		//this.dockPad
		if (this.useDockPad){this.buildDockPad()};
		this.padsVisible = true;
	},
		
	//builds launch pad for launching new applications and friend panels
	buildLaunchPad: function() {
		//tmpVariables for pads
		var dist1=this.homeSize/2+this.distFromBorder-QtAppMan.padWidth/2;		
		var dist2=this.homeSize*0.95+this.distFromBorder;
			
		//creates pad
		this.launchPad = new QtRectangleMorph(qrect(dist1, dist2, QtAppMan.padWidth,QtAppMan.padLength));
		this.setDefaults(this.launchPad);
		this.addMorph(this.launchPad);
		
		//adds circle in the end of pad
		var ellipse = this.newPadEllipse(dist1, dist2+QtAppMan.padLength-QtAppMan.padWidth/2);
		this.launchPad.addMorphBack(ellipse);
	
		//creates buttons
		var b1=new QPushButton();
		var b2=new QPushButton();

		//sets sizes
		b1.setFixedSize(QtAppMan.buttonSize,QtAppMan.buttonSize);
		b2.setFixedSize(QtAppMan.buttonSize,QtAppMan.buttonSize);
		b1.setIconSize(new QSize(QtAppMan.buttonSize,QtAppMan.buttonSize));
		b2.setIconSize(new QSize(QtAppMan.buttonSize,QtAppMan.buttonSize));
		
		//sets pictures
		b1.icon =this.plusIcon;
		b2.icon =this.usersIcon;

		//masks rectangle to cirle
		var mask = new QBitmap(new QPixmap("images/appman/mask.png").scaledToHeight(QtAppMan.buttonSize));
		b1.setMask(mask);
		b2.setMask(mask);
		
		//calculates variables
		var left=dist1;
		var top1 = dist2+3*(QtAppMan.padLength-2*QtAppMan.buttonSize)/5+10;
		var top2 = dist2+4*(QtAppMan.padLength-2*QtAppMan.buttonSize)/5+QtAppMan.padWidth+10;
		
		//sets proxy morphs
		this.appButton = new QtProxyMorph(b1, qrect(left, top1, QtAppMan.padWidth, QtAppMan.padWidth));
        this.usersButton = new QtProxyMorph(b2, qrect(left, top2, QtAppMan.padWidth, QtAppMan.padWidth));
		this.appButton.inner.pressed.connect(this, this.appLauncher);
		this.appButton.inner.released.connect(this, this.appButtonReleased);
		this.usersButton.inner.pressed.connect(this, this.userLauncher);
		this.usersButton.inner.released.connect(this, this.userButtonReleased);
		this.appButton.allowsManipulation(false);
		this.usersButton.allowsManipulation(false);

		//sets proxymorphvariables
		this.appButton.setBorderWidth(0);
		this.usersButton.setBorderWidth(0);
		this.appButton.setFillColor(QtColor.transparent);
        this.usersButton.setFillColor(QtColor.transparent);

		//adds buttons to this.launchPad
		this.launchPad.addMorph(this.appButton);
		this.launchPad.addMorph(this.usersButton);

		//moves buttons to right places
		this.appButton.moveTo(left,top1);
		this.usersButton.moveTo(left,top2);		
		
 		return;	
	},

	//builds this.dockPad for docking minimized items
	buildDockPad: function(){
		var needsSpinBox = false;
		var spinboxWidth = 50;

		//which items we are going to see
		var firstToShow=0;
		var lastToShow=this.dockPadItemList.length-1;
		if (this.dockPadItemList.length>this.maxItemNumber){
			needsSpinBox=true;
			lastToShow=(this.spinBoxValue+1)*this.maxItemNumber-1;
			if (lastToShow>=this.dockPadItemList.length){
				lastToShow=this.dockPadItemList.length-1;
			}
			firstToShow=lastToShow-this.maxItemNumber+1;
		}

		//calculates width needed for items
		var gap = 10;
		var width = gap;
		for (var i=firstToShow; i <= lastToShow; i ++){
			var item = this.dockPadItemList[i];
			var itemWidth=item.rect().width()*item.scaleFactor;
			width += itemWidth;
			width += gap;
		}
		if (needsSpinBox){
			width+=spinboxWidth;
		}

		//tmpVariables for pads
		var dist1=this.homeSize*0.95+this.distFromBorder;
		var dist2=this.homeSize/2+this.distFromBorder-QtAppMan.padWidth/2;		
		
		//creates dockpad
		this.dockPad = new QtRectangleMorph(qrect(dist1, dist2, width, QtAppMan.padWidth));
		this.setDefaults(this.dockPad);
		this.addMorphBack(this.dockPad);

		//inserts circle in the end of pad
		var ellipse = this.newPadEllipse(dist1+width-QtAppMan.padWidth/2, dist2);
		this.dockPad.addMorphBack(ellipse);		
		
		var y=this.dockPad.rect().y()+0.05*QtAppMan.padWidth;
		var x=this.dockPad.rect().x()+gap;

		//adds item to right place
		for (var i=0; i < this.dockPadItemList.length; i ++){
			var item = this.dockPadItemList[i];
			if (i>=firstToShow && i <= lastToShow){
				var width=item.rect().width()*item.scaleFactor;
				item.moveTo(x,y);
				item.peer.setZValue(QtMorph.newZValue(true));
				var button = this.buildMaximazeButton(item);
				this.dockPad.addMorphBack(button);	
				button.moveTo(x-button.rect().width()/2+width/2,15);

				//updates variables
				x += width;
				x += gap;
			}
		}

		//creates spinbox for browsing thru minimized apps
		if (needsSpinBox){
			var spinbox = new QSpinBox();
			this.spinBox = new QtProxyMorph(spinbox, qrect(0, 0, spinboxWidth, 0.7*QtAppMan.padWidth));
			this.spinBox.allowsManipulation(false);
			this.spinBox.setBorderWidth(0);
			this.spinBox.setFillColor(QtColor.transparent);
			this.addMorph(this.spinBox); 
			this.spinBox.peer.setZValue(QtMorph.newZValue(true));
			x += gap;
			this.spinBox.moveTo(x,y+0.1*QtAppMan.padWidth);
			var maxval=Math.ceil(this.dockPadItemList.length/this.maxItemNumber)-1;
			this.spinBox.inner.maximum = maxval;
			this.spinBox.inner.setValue(this.spinBoxValue);
			this.spinBox.inner['valueChanged(int)'].connect(this, this.spinBoxAction);
		}
	},

	buildMaximazeButton: function(item){

		var size = QtAppMan.buttonSize/2;
	
		var ellipse = new QtEllipseMorph(qrect(0,0, size+7, size+7));		
		this.setDefaults(ellipse);

		//creates buttons
		var b=new QPushButton();

		//sets sizes
		b.setFixedSize(size,size);
		b.setIconSize(new QSize(size,size));
		
		//sets pictures
		b.icon =this.restartIcon;

		//masks rectangle to cirle
		var mask = new QBitmap(new QPixmap("images/appman/mask.png").scaledToHeight(size));
		b.setMask(mask);
				
		//sets proxy morphs
        removeButton = new QtProxyMorph(b, qrect(0, 0, size, size));

		removeButton.parent=this;
		removeButton.itemToMaximaze=item;

		removeButton.removeButtonPressed= function(){
			this.inner.icon =this.parent.restartDownIcon;
		};
		//changes icon back to normal after button has been released
		removeButton.removeButtonReleased= function(){
			this.inner.icon =this.parent.restartIcon;
			this.parent.removeFromDockPad(this.itemToMaximaze);
		};

		removeButton.inner.pressed.connect(removeButton, removeButton.removeButtonPressed);
		removeButton.inner.released.connect(removeButton, removeButton.removeButtonReleased);
		removeButton.allowsManipulation(false);

		//sets proxymorphvariables
		removeButton.setBorderWidth(0);
		removeButton.setFillColor(QtColor.transparent);

		//adds buttons to this.launchPad
		ellipse.addMorph(removeButton);

		return ellipse;	
	},
	
	removeDockPad: function(){
		for (var i=0; i < this.dockPadItemList.length; i ++){
			var item = this.dockPadItemList[i];
			//hide item :)
			item.moveTo(-1000,-1000);			
		}

		this.removeMorph(this.spinBox);
		this.removeMorph(this.dockPad);
	},
	
	//updates docpad when spinbox is manipulated
	spinBoxAction:function(newValue){
		this.spinBoxValue = newValue;
		this.updateDockPad();
	},
	
	
	//adds morph to dockpad
	addToDockPad:function(morph){
		morph.beforeDockX=morph.getPos().x();
		morph.beforeDockY=morph.getPos().y();
		this.dockPadItemList.push(morph);
		morph.docked=true;
		morph.allowsManipulation(false);
		this.padsVisible=true;
		this.updateDockPad();
	},

	updateDockPad:function(){
		this.removeDockPad();
		if (this.padsVisible){
			this.buildDockPad();	
		}
	},
	
	//removes morph from dockpad and restores its previous features
	removeFromDockPad:function(morph){	
		var ratio = morph.scaleFactor;
		ratio=1/ratio;
		morph.scale(ratio, ratio);
		morph.scaleFactor=ratio;

		this.removeItemsFromDockPadItemList(morph);
		morph.docked=false;
		var x=morph.beforeDockX;
		var y=morph.beforeDockY;
		morph.moveTo(x,y);
		morph.allowsManipulation(true);
		this.updateDockPad();
	},

	removeItemsFromDockPadItemList: function (item) {
		var i = 0;
		while (i < this.dockPadItemList.length) {
			if (this.dockPadItemList[i] === item) {
				this.dockPadItemList.splice(i, 1);
			} else {
				i++;
			}
		}
	},
	
	//opens (and closes) application launcher
	appLauncher: function(foo) {
		if (this.appLauncherMorph===null){
			this.appLauncherMorph = new AppLauncherMorph(qrect(0, 0, 250, 150));
			this.appLauncherMorph.setPos(qpt(100, 130));
			that = QtWorldMorph.current().addMorph(this.appLauncherMorph);		
		}else{
			QtWorldMorph.current().removeMorph(this.appLauncherMorph);
			this.appLauncherMorph=null;
		}
		this.appButton.inner.icon = this.plusDownIcon;
    },

	//opens (and closes) friend list 
	userLauncher: function(foo) {
		if (this.userLauncherMorph===null){
			this.userLauncherMorph = new UserLauncherMorph(qrect(0, 0, 250, 150));
			this.userLauncherMorph.setPos(qpt(100, 190));
			that = QtWorldMorph.current().addMorph(this.userLauncherMorph);		
		}else{
			QtWorldMorph.current().removeMorph(this.userLauncherMorph);
			this.userLauncherMorph=null;
		}
		this.usersButton.inner.icon = this.usersDownIcon;
    },
	
	//changes icon back to normal after button has been released
	appButtonReleased: function(foo) {
		this.appButton.inner.icon = this.plusIcon;
	},
	
	//changes icon back to normal after button has been released
	userButtonReleased: function(foo) {
		this.usersButton.inner.icon = this.usersIcon;
	},
	
	setDefaults: function(morph){
		morph.setFillColor(this.fillColor);
        morph.setBorderColor(this.borderColor);
        morph.setBorderWidth(this.borderWidth);
		morph.setOpacity(this.opacity);		
	},

	newPadEllipse:function(x,y){
		var ellipse = new QtEllipseMorph(qrect(x,y, QtAppMan.padWidth, QtAppMan.padWidth));		
		this.setDefaults(ellipse);
		return ellipse;
	},
	
	//gradient for background
	homeGradient: (function() {
        var gradient = new QLinearGradient(0, 0, 0, 100);
        gradient.setColorAt(0, QtColor.lightGray);
		gradient.setColorAt(1, QtColor.white);
        gradient.setSpread(QGradient.ReflectSpread);
        return gradient;
    })() 
});

Object.extend(QtAppMan, {
	padWidth: 60,
	padLength: 100,
	buttonSize:55,
	appMan:null,
	
	minimize: function(thisMorph){ 
		//if we havent got any morph then we hope that we will find one from QtEvents
		if (thisMorph===false){
			var thisMorph = QtEvents.currentMorph;		
		}
		//if morph is found then it is minimized
        if (thisMorph){ 
			if (thisMorph.allowsScaling){
				var height=thisMorph.rect().height();
				var width=thisMorph.rect().width();
				var ratio = 0.9*QtAppMan.padWidth/height;
				thisMorph.scale(ratio, ratio);
				thisMorph.scaleFactor=ratio;
				width=thisMorph.rect().width();
				QtAppMan.appMan.addToDockPad(thisMorph);
			}
		}
	}	
});

QtMorph.addMethods({

	allowsManipulation:function(value){
	    this.allowsMoving = value;
        this.allowsCopying = value;
        this.allowsResizing = value;
        this.allowsRotation = value;
        this.allowsScaling = value;
        this.allowsShearing = value;
	 },
   
	mousePressEvent: function(event) {
        if (QtEvents.userInterfaceLocked) return;
        
        // Process only left mouse button clicks here
        // (right button is reserved for contextMenuEvents)
        if ((event.buttons() & Qt.LeftButton) == 0) {
            QtEvents.leftMouseButtonPressed = false;
            return;
        }
		
        // Bring the item to the top and give it focus
        this.setZValue(QtMorph.newZValue(true));
        this.setFocus();
//        this.scene().setActiveWindow(this);

        // Store a pointer to the morph that was clicked
        QtEvents.currentMorph = PeerToMorphTable.get(this.data(0));
        // print("Mouse pressed on: " + QtEvents.currentMorph + ", event: " + event);

        // Make the morph available to the programmer via 'that'
        if (QtEvents.currentMorph)
             that = QtEvents.currentMorph;
        else that = null;

		var morph = QtEvents.currentMorph;
		if (morph) {
			if (morph.docked===true){
				QtAppMan.appMan.removeFromDockPad(morph);
				return;
			}
		}
		
        // Store the location of the event
        QtEvents.lastMouseDownPos = qpt(event.scenePos().x(), event.scenePos().y());

        // Record the difference between the mouse click 
        // and the position of the object; we need the diff
        // info, e.g., when moving the object
        QtEvents.eventPosDiff = qpt(event.scenePos().x(), event.scenePos().y());
        QtEvents.eventPosDiff.operator_subtract_assign(this.scenePos());

        QtEvents.leftMouseButtonPressed = true;
        QtEvents.mouseWasDragged = false;

        // Check if Shift key is down, i.e., the user wants to copy the object
        if (event.modifiers() & Qt.ShiftModifier) {
            // Copy the current morph
            if (morph) {
                var newMorph = morph.copy();
                var currentWorld = QtWorldMorph.current();
                if (newMorph && currentWorld) {
                    currentWorld.addMorph(newMorph);
                    newMorph.setPos(QtEvents.lastMouseDownPos);
                    that = newMorph;
                    QtEvents.currentMorph = null;
                    return; // Done with copying!
                }            
            }
        }

        QtEvents.transformationInProgress = false;
        if (!that) return;

        // Check for transformation requests (resizing, rotation, scaling, ...)
        if (that.allowsResizing && that.mouseOnResizeHandle(event)) {
            QtEvents.transformationInProgress = QtEvents.RESIZING;
            that.setHelpText(event, "Resizing...", 10);
            return;
        }

        if (that.allowsRotation && that.mouseOnRotationHandle(event)) {
            QtEvents.transformationInProgress = QtEvents.ROTATING;
            that.setHelpText(event, "Rotating...", 10);
            return;
        }

        if (that.allowsScaling && that.mouseOnScalingHandle(event)) {
            QtEvents.transformationInProgress = QtEvents.SCALING;
            that.setHelpText(event, "Scaling...", -50);
            return;
        }

        if (that.allowsShearing && that.mouseOnShearingHandle(event)) {
            QtEvents.transformationInProgress = QtEvents.SHEARING;
            that.setHelpText(event, "Shearing...", -60);
            return;
        }
	 }
});


/*QtAppMan.prototype.mouseMoveEvent = function(event){
		var i=100;
}*/