//layoutholder from qtpayazzo
LayoutHolder.prototype = new QWidget();
function LayoutHolder(parent, layout)
{
    QWidget.call(this, parent);
    this.l = layout;
    this.setLayout(layout);
}

QtLogin.prototype = new QWidget();

function QtLogin(parent)
{
	QtLogin.userName="Anonymous";
    QWidget.call(this);
	//sets right layout
	this.setLoginLayout();
}

//sets layout for logging in and registering
QtLogin.prototype.setLoginLayout = function(){
    this.loggedIn = new QLabel();
	this.loggedIn.text="not logged in";
	
	//editfields
    this.userNameEdit = new QLineEdit(this);
    this.userNameEdit.text = "username";
    this.passWordEdit = new QLineEdit(this);
    this.passWordEdit.text = "password";
	
	//buttons
	this.loginButton = new QPushButton("Login", this);
    this.loginButton.clicked.connect(this, this.login);
	this.registerButton = new QPushButton("Register", this);
    this.registerButton.clicked.connect(this, this.register);

	//editfieldlayout
	var formLayout = new QFormLayout();	
    formLayout.addRow("", this.loggedIn);
    formLayout.addRow("Username:", this.userNameEdit);
    formLayout.addRow("Password:", this.passWordEdit);
	
	//buttonlayout
	var buttonLayout = new QHBoxLayout();
    buttonLayout.addStretch();
    buttonLayout.addWidget(this.registerButton, 0, 0);
    buttonLayout.addWidget(this.loginButton, 0, 0);

	//combines editfields and buttons
    var layout = new QVBoxLayout();
    layout.addLayout(formLayout);
    layout.addLayout(buttonLayout);

	//sets current layout
	this.setCurrentLayout(layout);
};

//sets current layout and removes the previous one
QtLogin.prototype.setCurrentLayout = function(layout){
    if (this.layoutholder) {
		//removes previous layoutholder
        this.mainlayout.removeWidget(this.layoutholder);
        this.layoutholder.setParent(null);
    }else{
		//sets mainlayout
		this.mainlayout = new QVBoxLayout();
		this.mainlayout.setContentsMargins(0, 0, 0, 0);
		this.setLayout(this.mainlayout);	
	}
	//sets new layout to mainlayout
    this.mainlayout.removeWidget(this.layoutholder);
	this.layoutholder = new LayoutHolder(this, layout);
    this.mainlayout.addWidget(this.layoutholder, 0, 0);
};

//layout for logging out
QtLogin.prototype.setLogoutLayout = function(){
	//logged in label
    this.loggedIn = new QLabel();
	this.loggedIn.text="logged in as " + QtLogin.userName;

	//button for logging out
	this.logoutButton = new QPushButton("Logout", this);
    this.logoutButton.clicked.connect(this, this.logout);

	//layouts
	var formLayout = new QFormLayout();	
    formLayout.addRow("", this.loggedIn);
	var buttonLayout = new QHBoxLayout();
    buttonLayout.addStretch();
    buttonLayout.addWidget(this.logoutButton, 0, 0);

    var layout = new QVBoxLayout();
    layout.addLayout(formLayout);
    layout.addLayout(buttonLayout);

	//sets new layout for current layout
	this.setCurrentLayout(layout);
};

//function for logging out
QtLogin.prototype.logout = function(){
	//sets loginlayout
	this.setLoginLayout();
	QtLogin.userName="Anonymous";
};

//function for loggin in
QtLogin.prototype.login = function()
{
	this.loggedIn.text="Connecting to the database";
	//checks accounts
	this.getAccounts();
	this.logging=true;
	this.registering=false;
};

//second phase of logging in
QtLogin.prototype.login2 = function(accounts)
{
	//user input fields
	var username=this.userNameEdit.text;
	var password=this.passWordEdit.text;
	var found = false;
	
	//goes thru all accounts and checks if right one is found
	for (var i = 0; i < accounts.length; i ++){
		if (accounts[i].username===username&&accounts[i].password===password){
			this.loggedIn.text="Logged in as " + username;
			found=true;
		}
	}

	QtLogin.userName=username;
	
	//if right one 
	if (found){
		this.setLogoutLayout();
	}else{
		this.loggedIn.text="Illegal username or password. Please, try again.";
	}
};

QtLogin.prototype.register = function()
{
	this.getAccounts();
	this.registering=true;
	this.logging=false;
};

QtLogin.prototype.register2 = function(accounts)
{
	var username=this.userNameEdit.text;
	var password=this.passWordEdit.text;
	var found = false;
	
	for (var i = 0; i < accounts.length; i ++){
		if (accounts[i].username===username){
			this.loggedIn.text="Select another username.";
			found=true;
		}
	}
	if (!found){
		this.addAccount(username,password);
		QtLogin.userName=username;
		this.loggedIn.text="Logged in as " + username;
		this.setLogoutLayout();
	}
};

QtLogin.prototype.addAccount = function(username,password){
		var url = 'http://lively.cs.tut.fi:8010/Account/';
		var accessManager = new QNetworkAccessManager(this);
		var account={};
		account.username=username;
		account.password=password;
		var json = JSON.stringify(account);
		var data = new QByteArray(json);
		accessManager["finished(QNetworkReply*)"].connect(this, this.accountAdded);
		accessManager.post(new QNetworkRequest(new QUrl(url)),data);
};

QtLogin.prototype.accountAdded = function(){
};

QtLogin.prototype.getAccounts = function()
{
	var url = 'http://lively.cs.tut.fi:8010/Account/'; 
	var accessManager = new QNetworkAccessManager(this);
	accessManager["finished(QNetworkReply*)"].connect(this, this.accountsGot);
	accessManager.get(new QNetworkRequest(new QUrl(url)));
};

QtLogin.prototype.accountsGot = function(reply)
{
	var accounts=QPersevereAccessManager.parseReply(reply);
	if (this.logging){
		this.login2(accounts);			
	}else if(this.registering){
		this.register2(accounts);
	}
};