function tr(s) { return s; }

// Returns the number of the month (January == 1, February == 2 ...).
Date.prototype.getKuukausi = function () {
    return this.getMonth() + 1;
}

Date.prototype.setKuukausi = function (kuukausi) {
    this.setMonth(kuukausi - 1);
}

// Functions to calculate week number. Ripped from: http://javascript.about.com/library/blstdweek.htm
Date.prototype.getMDay = function() {
    return (this.getDay() + 6) %7;
}
Date.prototype.getISOYear = function() {
    var thu = new Date(this.getFullYear(), this.getMonth(), this.getDate()+3-this.getMDay());
    return thu.getFullYear();
}
Date.prototype.getISOWeek = function() {
    var onejan = new Date(this.getISOYear(),0,1);
    var wk = Math.ceil((((this - onejan) / 86400000) + onejan.getMDay()+1)/7);
    if (onejan.getMDay() > 3) wk--;return wk;
}

function QtProjectCalendar(parent)
{
    QWidget.call(this, parent);

    this.events = [];
    this.note = "";
    this.selectedDate = new Date();

    this.tabWidget = new QTabWidget(this);
    this.monthTab = new monthTab(this);
    this.weekTab = new weekTab(this);
    this.tabWidget.addTab(this.weekTab, tr("&Week"));
    this.tabWidget.addTab(this.monthTab, tr("&Month"));
    this.tabWidget["currentChanged(int)"].connect(this, this.tabChanged);

    // Get all the events sorted by date and startTime.
    var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/[/eventDate, /startTime]';
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this, this.getEvents);
    accessManager.get(new QNetworkRequest(new QUrl(url)));

    // Get the note.
    var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarNote/';
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this, this.getNote);
    accessManager.get(new QNetworkRequest(new QUrl(url)));

    this.layout = new QVBoxLayout(this);
    this.layout.addWidget(this.tabWidget,0,0);
     
    this.windowTitle = tr("Simple Calendar");
    this.resize(800, 600);

    // Define styles to improve visual look.
    this.setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0.45, y2: 0.45, stop: 0 orange, stop: 1 black); color: white;");
    this.tabWidget.setStyleSheet("QTabWidget::tab-bar { left: 10px; } QTabBar::tab { min-width: 200px; background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 0.25, stop: 0 orange, stop: 1.0 black); border: 1px solid #9B9B9B; border-bottom-color: orange; border-top-left-radius: 4px; border-top-right-radius: 4px; min-width: 8ex; padding: 2px; } QTabBar::tab:selected, QTabBar::tab:hover { background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1, stop: 0 orange, stop: 1.0 black); } QTabBar::tab:selected { border-color: #9B9B9B; border-bottom-color: orange; }");

}

QtProjectCalendar.prototype = new QWidget();

QtProjectCalendar.prototype.resizeEvent = function (event)
{
    this.weekTab.updateWeekCalendar();
}

QtProjectCalendar.prototype.tabChanged = function ()
{
    this.monthTab.updateMonthCalendar();
    this.weekTab.updateWeekCalendar();
    this.monthTab.monthCombo.setCurrentIndex(this.selectedDate.getMonth());
    this.monthTab.yearEdit.setDate(this.selectedDate);
}

QtProjectCalendar.prototype.getEvents = function(reply) {
    var eventsJSONString = reply.readAll().toString();
    var eventsJSONObject = eval('(' + eventsJSONString + ')'); 
    // If there is an error in the JSON or there are no events in the db, 
    // mark events as zero.
    if(eventsJSONObject.error || eventsJSONObject.length == 0)
    {
        this.events = [];
    }
    else
    {
        // Save all the events.
        this.events = [];
        for (i = 0; i < eventsJSONObject.length; i++)
        {
            this.events[i] = [];
            this.events[i][0] = eventsJSONObject[i].id;
            this.events[i][1] = eventsJSONObject[i].eventDate;
            this.events[i][2] = eventsJSONObject[i].topic;
            this.events[i][3] = eventsJSONObject[i].place;
            this.events[i][4] = eventsJSONObject[i].startTime;
            this.events[i][5] = eventsJSONObject[i].endTime;
            this.events[i][6] = eventsJSONObject[i].recurrence;
        }
    }

    // Refresh the calendar.
    this.monthTab.updateMonthCalendar();
    this.weekTab.updateWeekCalendar();
    this.monthTab.updateEventsLayout();
}

QtProjectCalendar.prototype.getNote = function(reply) {
    var eventsJSONString = reply.readAll().toString();
    var eventsJSONObject = eval('(' + eventsJSONString + ')'); 
    // If there is an error in the JSON or there are no events in the db, 
    // mark events as zero.
    if(eventsJSONObject.error || eventsJSONObject.length == 0)
    {
        this.note = "";
    }
    else
    {
        // Save the note.
        this.note = eventsJSONObject[0].note;
    }

    // Refresh the note.
    this.monthTab.updateNote();
}


monthTab.prototype = new QWidget();

function monthTab(parent)
{
    QWidget.call(this, parent);

    this.parent = parent;
    this.controlsLayout = new QHBoxLayout();
    this.eventsLayout = new QGridLayout();

    var horizontalHeaders = new Array(7);
    horizontalHeaders[0]="Monday";
    horizontalHeaders[1]="Tuesday";
    horizontalHeaders[2]="Wednesday";
    horizontalHeaders[3]="Thursday";
    horizontalHeaders[4]="Friday";
    horizontalHeaders[5]="Saturday";
    horizontalHeaders[6]="Sunday";

    var months = new Array(12);
    months[0]="January";
    months[1]="February";
    months[2]="March";
    months[3]="April";
    months[4]="May";
    months[5]="June";
    months[6]="July";
    months[7]="August";
    months[8]="September";
    months[9]="October";
    months[10]="November";
    months[11]="December";

    var eventHeaders = new Array(1);
    eventHeaders[0]="Upcoming events:";

    this.monthCombo = new QComboBox;
    for (month = 0; month <= 11; ++month)
    {
        this.monthCombo.addItem(months[month]);
    }
    this.monthCombo.setCurrentIndex(this.parent.selectedDate.getMonth());
    this.monthCombo.maxVisibleItems = 12;
    this.monthCombo.setStyleSheet("background-color: black");

    this.yearEdit = new QDateTimeEdit;
    this.yearEdit.setDateRange(Date(1753, 1, 1), Date(8000, 1, 1));    
    this.yearEdit.setDate(this.parent.selectedDate);
    this.yearEdit.displayFormat = "yyyy";
    this.yearEdit.setStyleSheet("background-color: black");

    this.monthCombo["currentIndexChanged(int)"].connect(this, this.selectMonth);
    this.yearEdit["dateChanged(QDate)"].connect(this, this.selectYear);

    this.table = new QTableWidget(1,7);
    this.table["cellActivated(int, int)"].connect(this, this.openDay);

    var header;
    header = this.table.horizontalHeader();
    header.setResizeMode(QHeaderView.Stretch);
    header.setClickable(false);
    header = this.table.verticalHeader();
    header.setResizeMode(QHeaderView.ResizeToContents);
    header["sectionClicked(int)"].connect(this, this.openWeek);
    this.table.setHorizontalHeaderLabels(horizontalHeaders);
    this.table.horizontalHeader().setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 0.25, stop: 0 gray, stop: 1 black); color: white; font: bold 14px;");
    this.table.verticalHeader().setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0.25, y2: 0, stop: 0 gray, stop: 1 black); color: white; font: bold 14px;");

    this.eventsTable = new QTableWidget(1,1);
    header = this.eventsTable.horizontalHeader();
    header.setResizeMode(QHeaderView.Stretch);
    header.setClickable(false);
    this.eventsTable.setHorizontalHeaderLabels(eventHeaders);
    header = this.eventsTable.verticalHeader();
    header.setVisible(false);
    this.eventsTable.horizontalHeader().setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 0.25, stop: 0 gray, stop: 1 black); color: white; font: bold 14px;");

    this.notesLabel = new QLabel("Notes:");
    this.notesLabel.alignment = 4;
    this.notesLabel.setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 0.25, stop: 0 gray, stop: 1 black); color: white; font: bold 14px; border: 1px solid white; border-bottom-color: grey; border-right-color: grey; padding: 2px;");
    this.notePad = new QTextEdit();
    this.notePad.setStyleSheet("background-color: white; color: black;");
    this.notePad["textChanged()"].connect(this, this.saveNote);

    this.groupBox = new QGroupBox(tr(""));
    this.groupBox.setStyleSheet("background-color: black; padding: 0px;");
    this.vbox = new QVBoxLayout();
    this.vbox.addWidget(this.notesLabel, 0, 0);
    this.vbox.addWidget(this.notePad, 1, 0);
    this.groupBox.setLayout(this.vbox);

    this.controlsLayout.addWidget(this.monthCombo, 0, 0);
    this.controlsLayout.addWidget(this.yearEdit, 0, 0);
    this.controlsLayout.addStretch(1);

    this.eventsLayout.addWidget(this.eventsTable, 0, 0, 1, 1);
    this.eventsLayout.addWidget(this.groupBox, 0, 1, 1, 1);

    this.layout = new QVBoxLayout(this);
    this.layout.addLayout(this.controlsLayout);
    this.layout.addWidget(this.table, 0, 0);
    this.layout.addLayout(this.eventsLayout, 1);
}

monthTab.prototype.selectMonth = function(month) {
    this.parent.selectedDate.setKuukausi(month + 1);

    // Refresh the calendar.
    this.updateMonthCalendar();
}

monthTab.prototype.selectYear = function(newDate) {
    this.parent.selectedDate.setFullYear(newDate.getFullYear());
    
    // Refresh the calendar.
    this.updateMonthCalendar();
}

monthTab.prototype.openDay = function(selectedRow, selectedColumn) {

    if (this.table.item(selectedRow, selectedColumn).text() == "")
    {
        return;
    }

    this.parent.selectedDate.setDate(this.table.item(selectedRow, selectedColumn).text());

    this.eDialog = new eventDialog(this, this.parent.selectedDate, this.parent.events);

    // Update events.
    var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/[/eventDate, /startTime]';
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this.parent, this.parent.getEvents);
    accessManager.get(new QNetworkRequest(new QUrl(url)));
    
}

monthTab.prototype.openWeek = function(logicalIndex) {

    var selectedRow = logicalIndex;
    var selectedColumn = 0;

    // Find the first day of the selected week.
    while (this.table.item(selectedRow, selectedColumn).text() == "")
    { 
        selectedColumn++;
    }

    this.parent.selectedDate.setDate(this.table.item(selectedRow, selectedColumn).text());

    // Show calendar of the selected week.
    this.parent.weekTab.updateWeekCalendar();
    this.parent.tabWidget.setCurrentIndex(0);
    
}

monthTab.prototype.updateNote = function() {
    this.notePad.setText(this.parent.note);
}

monthTab.prototype.saveNote = function(event) {

    var baseStr = 'http://lively.cs.tut.fi:8010/SimpleCalendarNote/1';    
    var jsonStr = '{"note":"' + this.notePad.plainText + '"}';
    var jsonArr = new QByteArray(jsonStr);
    var req = new QNetworkRequest(new QUrl(baseStr));

    // QNetworkAccessManager for network requests
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this, this.saveEvent);
    
    // Send the HTTP/PUT request to update the existing event-object.
    accessManager.put(req, jsonArr);

}

monthTab.prototype.saveEvent = function(reply) {
    var data = reply.readAll().toString();
    print(data);
}

monthTab.prototype.updateEventsLayout = function() {

    var eDate;
    var currentDate = new Date();
    var tableItem;
    var iFlags = new Qt.ItemFlags(Qt.ItemIsEnabled);
    
    // Clear tables.
    while (this.eventsTable.rowCount > 0)
    {
        this.eventsTable.removeRow(this.eventsTable.rowCount - 1);
    }

    for (j = 0; j < this.parent.events.length; j++)
    {
        // Skip the old events.
        eDate = new Date();
        eDate.setFullYear(this.parent.events[j][1].slice(0,4));
        eDate.setMonth(this.parent.events[j][1].slice(5,7) - 1);
        eDate.setDate(this.parent.events[j][1].slice(8));
        if (eDate > currentDate)
        {
            eDate = this.parent.events[j][1].slice(8) + "." + this.parent.events[j][1].slice(5,7);
            tableItem = new QTableWidgetItem(tr(eDate + ": " + this.parent.events[j][4] + "-" + this.parent.events[j][5] + " - " + this.parent.events[j][2]));
            tableItem.setFlags(0);

            this.eventsTable.insertRow(this.eventsTable.rowCount);
            this.eventsTable.setItem(this.eventsTable.rowCount - 1, 0, tableItem);

        }
    }
    
}

monthTab.prototype.updateMonthCalendar = function () {

    var currentDate = new Date();
    var newDate = new Date();
    newDate.setFullYear(this.parent.selectedDate.getFullYear());
    newDate.setKuukausi(this.parent.selectedDate.getKuukausi());
    newDate.setDate(1);
    var tableItem;
    var tableDay;
    var weekDayCounter;
    var eCounter;
    var iFlags = new Qt.ItemFlags(Qt.ItemIsEnabled);
    var brush_yellow = new QBrush(new QColor("gold"));
    var brush_orange = new QBrush(new QColor("goldenrod"));
    var brush_orangered = new QBrush(new QColor("darkorange"));
    var brush_crimson = new QBrush(new QColor("orangered"));
    var brush_darkred = new QBrush(new QColor("firebrick"));
    var brush_black = new QBrush(new QColor("black"));
    var strongFont = new QFont();
    strongFont.setBold(true);
    strongFont.setUnderline(true);
    var verticalHeaders = new Array();

    verticalHeaders.push(newDate.getISOWeek());

    // Clear table.
    while (this.table.rowCount > 1)
    {
        this.table.removeRow(this.table.rowCount - 1);
    }

    // 0 == sunday, 1 == monday, ... , 6 == saturday. 
    weekDayCounter = newDate.getDay() - 1;
    if (weekDayCounter < 0)
    {
        weekDayCounter = 6;
    }

    // Disable cells before the first day of the month.
    for (i = 0; i < weekDayCounter; i++)
    {
        tableItem = new QTableWidgetItem("");
        tableItem.setFlags(0);
        
        this.table.setItem(this.table.rowCount - 1, i, tableItem);
    }

    while (newDate.getKuukausi() == this.parent.selectedDate.getKuukausi())
    {
        tableItem = new QTableWidgetItem((newDate.getDate()).toString());
        tableItem.setFlags(iFlags);
        tableItem.setTextAlignment(1);

        // Mark the current day with bold text.
        if (newDate.getDate() == currentDate.getDate() && newDate.getKuukausi() == currentDate.getKuukausi()
            && newDate.getFullYear() == currentDate.getFullYear())
        {
            tableItem.setFont(strongFont);
        }

        // Check if the date got an event.
        for (j = 0; j < this.parent.events.length; j++)
        {
            if (this.parent.events[j][1] == newDate.getFullYear() + '_' + newDate.getKuukausi() + '_' + newDate.getDate())
            {
                // Count the events.
                eCounter++;
                tableItem.setForeground(brush_black);

                // Display the events as tooltip.
                tableItem.setToolTip(tableItem.toolTip() + "\n" + this.parent.events[j][4] + "-" + this.parent.events[j][5] + " - " + this.parent.events[j][2]);
            }
        }
        
        if (eCounter == 1)
        {
            tableItem.setBackground(brush_yellow);
        }
        else if (eCounter == 2)
        {
            tableItem.setBackground(brush_orange);
        }
        else if (eCounter == 3)
        {
            tableItem.setBackground(brush_orangered);
        }
        else if (eCounter == 4)
        {
            tableItem.setBackground(brush_crimson);
        }
        else if (eCounter > 4)
        {
            tableItem.setBackground(brush_darkred);
        }
        eCounter = 0;

        this.table.setItem(this.table.rowCount - 1, weekDayCounter, tableItem);

        newDate.setDate(newDate.getDate()+1);

        if (weekDayCounter == 6 && newDate.getKuukausi() == this.parent.selectedDate.getKuukausi())
        {
            this.table.insertRow(this.table.rowCount);
            weekDayCounter = 0;
            verticalHeaders.push(newDate.getISOWeek());
        }
        else
        {
            weekDayCounter++;
        }
    }

    // Disable cells after the last day of the month.
    for (i = weekDayCounter; i < 7; i++)
    {
        tableItem = new QTableWidgetItem("");
        tableItem.setFlags(0);
        
        this.table.setItem(this.table.rowCount - 1, i, tableItem);
    }

    // Show weeknumbers.
    this.table.setVerticalHeaderLabels(verticalHeaders);
    header = this.table.verticalHeader();
    header.setClickable(true);

}


weekTab.prototype = new QWidget();

function weekTab(parent)
{
    QWidget.call(this, parent);

    this.parent = parent;
    this.controlsLayout = new QHBoxLayout();
    var tableDay;
    var header;
    var eCounter;
    var duration;
    var iFlags = new Qt.ItemFlags(Qt.ItemIsEnabled);

    this.previousWeek = new QPushButton(tr("<"));
    this.previousWeek.setStyleSheet("background-color: black; font: bold 14px;");
    this.nextWeek = new QPushButton(tr(">"));
    this.nextWeek.setStyleSheet("background-color: black; font: bold 14px;");
    this.addEventButton = new QPushButton(tr("Add event"));
    this.addEventButton.setStyleSheet("min-width: 200px; min-height: 25px; margin: 0 0 0 20px;");
    this.previousWeek["clicked()"].connect(this, this.previousWeekClicked);
    this.nextWeek["clicked()"].connect(this, this.nextWeekClicked);
    this.addEventButton["clicked()"].connect(this, this.addEvent);

    this.scene = new QGraphicsScene();
    this.scene.itemIndexMethod = QGraphicsScene.NoIndex;
    this.view = new QGraphicsView(this.scene);
    //this.view.setViewport(new QGLWidget());
    this.scene["selectionChanged()"].connect(this, this.eventSelected);

    var verticalHeaders = new Array(24);
    verticalHeaders[0]="00:00";
    verticalHeaders[1]="02:00";
    verticalHeaders[2]="04:00";
    verticalHeaders[3]="06:00";
    verticalHeaders[4]="08:00";
    verticalHeaders[5]="10:00";
    verticalHeaders[6]="12:00";
    verticalHeaders[7]="14:00";
    verticalHeaders[8]="16:00";
    verticalHeaders[9]="18:00";
    verticalHeaders[10]="20:00";
    verticalHeaders[11]="22:00";

    var horizontalHeaders = new Array(7);
    horizontalHeaders[0]="Monday";
    horizontalHeaders[1]="Tuesday";
    horizontalHeaders[2]="Wednesday";
    horizontalHeaders[3]="Thursday";
    horizontalHeaders[4]="Friday";
    horizontalHeaders[5]="Saturday";
    horizontalHeaders[6]="Sunday";

    this.table = new QTableWidget(1,7);

    // Insert empty calendar.
    for (i = 0; i < 11; i++)
    {
        this.table.insertRow(this.table.rowCount);
    }
    this.table.setSpan(0, 0, 12, 7);

    header = this.table.verticalHeader();
    header.setClickable(false);
    header.setResizeMode(QHeaderView.Stretch);
    this.table.setVerticalHeaderLabels(verticalHeaders);
    this.table.verticalHeader().setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0.25, y2: 0, stop: 0 gray, stop: 1 black); color: white; font: bold 14px;");

    header = this.table.horizontalHeader();
    header.setClickable(false);
    header.setResizeMode(QHeaderView.Stretch);
    this.table.horizontalHeader().setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 0.25, stop: 0 gray, stop: 1 black); color: white; font: bold 14px;");
    this.table.setHorizontalHeaderLabels(horizontalHeaders);

    this.controlsLayout.addWidget(this.previousWeek, 0, 0);
    this.controlsLayout.addWidget(this.nextWeek, 0, 0);
    this.controlsLayout.addWidget(this.addEventButton, 0, 0);
    this.controlsLayout.addStretch(0);

    this.layout = new QVBoxLayout(this);
    this.layout.addLayout(this.controlsLayout);
    this.layout.addWidget(this.table, 0, 0);

    // Draw calendar with events.
    this.table.setViewport(this.view);
    this.scene.setSceneRect(0, 0, this.view.width, this.view.height);
    this.updateWeekCalendar();

}

weekTab.prototype.previousWeekClicked = function() {

    this.parent.selectedDate.setDate(this.parent.selectedDate.getDate() - 7);
    this.updateWeekCalendar();
}

weekTab.prototype.nextWeekClicked = function() {

    this.parent.selectedDate.setDate(this.parent.selectedDate.getDate() + 7);
    this.updateWeekCalendar();
}

weekTab.prototype.addEvent = function(column) {

    var eDate = this.parent.selectedDate;
    this.modifyDialog = new modifyDialog(this, eDate, "");
    
    // Create a query to update the events.
    var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/[/eventDate, /startTime]';
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this.parent, this.parent.getEvents);
    accessManager.get(new QNetworkRequest(new QUrl(url)));
}

// TODO: Glued together at the moment. Selected event is parsed from the unique z-value.
weekTab.prototype.eventSelected = function() {

    var graphicsItem = this.scene.selectedItems();
    var dataString = graphicsItem.toString();

    var startPoint = dataString.indexOf("z =");
    var endPoint = dataString.indexOf("flags");

    var zValue = dataString.slice(startPoint + 3, endPoint - 2);
    var eDate = new Date(); 

    // Find corresponding event.
    for (j = 0; j < this.parent.events.length; j++)
    {
        if (this.parent.events[j][0] == zValue)
        {
            endPoint = this.parent.events[j][1].lastIndexOf("_");
            eDate.setDate(this.parent.events[j][1].slice(endPoint + 1));
            eDate.setMonth(this.parent.events[j][1].slice(5, endPoint) - 1);
            eDate.setFullYear(this.parent.events[j][1].slice(0, 4));

            this.modifyDialog = new modifyDialog(this, eDate, this.parent.events[j]);

            // Create a query to update the events for the week.
            var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/[/eventDate, /startTime]';
            var accessManager = new QNetworkAccessManager(this);
            accessManager["finished(QNetworkReply*)"].connect(this.parent, this.parent.getEvents);
            accessManager.get(new QNetworkRequest(new QUrl(url)));
        }
    }

}

weekTab.prototype.updateWeekCalendar = function () {

    var weekDayCounter = 0;
    var horizontalHeaders = new Array();
    var tableItem;
    var strongFont = new QFont();
    strongFont.setBold(true);
    strongFont.setUnderline(true);
    var roundRectPath;
    var graphicsPathItem;
    var graphicsTextItem;
    var startTime;
    var endTime;
    var eventStart;
    var eventEnd;
    var duration;
    var zCounter = 0;
    var collides = false;
    var collisions = 0;

    var currentDate = new Date();
    var newDate = new Date();
    newDate.setFullYear(this.parent.selectedDate.getFullYear());
    newDate.setKuukausi(this.parent.selectedDate.getKuukausi());
    newDate.setDate(this.parent.selectedDate.getDate());

    // Find the first day of the week (monday).
    while (newDate.getDay() != 1)
    {
        newDate.setDate(newDate.getDate()-1);
    }

    // Clear the scene.
    this.scene.clear();

    // Draw a border box.
    var viewWidth = this.view.width;
    var viewHeight = this.view.height;
    //this.scene.setSceneRect(0, 0, this.table.width, this.table.height - 5);
    this.scene.setSceneRect(0, 0, viewWidth, viewHeight);
    this.view.updateSceneRect(new QRectF(0, 0, viewWidth, viewHeight));
    this.view.horizontalScrollBarPolicy = Qt.ScrollBarAlwaysOff;
    this.view.verticalScrollBarPolicy = Qt.ScrollBarAlwaysOff;

    // Draw events in calendar for each weekday.
    var counter = 0;
    while (counter <= 6)
    {
        // Check if date got an event.
        for (j = 0; j < this.parent.events.length; j++)
        {
            if (this.parent.events[j][1] == newDate.getFullYear() + '_' + newDate.getKuukausi() + '_' + newDate.getDate())
            {
                // Find events starting and ending times.
                startTime = (this.parent.events[j][4]).slice(0, 2);
                endTime = (this.parent.events[j][5]).slice(0, 2);

                // Check if event ends on the next day.
                if (endTime < startTime)
                {
                    endTime = 24;
                }
                if (endTime == startTime)
                {
                    duration = 1;
                }
                else
                {
                    duration = endTime - startTime;
                }

                collides = false;
                collisions = 0;

                // Check if the event collides with another event that has already been drawn.
                for (k = 0; k < j; k++)
                {
                    if (this.parent.events[j][1] == this.parent.events[k][1])
                    {
                        eventStart = (this.parent.events[k][4]).slice(0, 2);
                        eventEnd = (this.parent.events[k][5]).slice(0, 2);
                        if (eventEnd < eventStart)
                        {
                            eventEnd = 24;
                        }
                        
                        if (startTime == eventStart || (startTime > eventStart && startTime < eventEnd))
                        {
                            collides = true;
                            collisions++;
                        }
                    }
                }

                if (collisions > 3)
                {
                    collisions = 3;
                }

                // Draw event as a rounded box.
                roundRectPath = new QPainterPath();
                roundRectPath.moveTo(counter * (viewWidth / 7) + (viewWidth / 7), startTime * (viewHeight / 24) - 5.0);
                roundRectPath.arcTo(counter * (viewWidth / 7) + (viewWidth / 7) - 10.0, startTime * (viewHeight / 24), 10.0, 10.0, 0.0, 90.0);
                roundRectPath.lineTo(counter * (viewWidth / 7) + 5 + (collisions * (viewWidth / 28)), startTime * (viewHeight / 24));
                roundRectPath.arcTo(counter * (viewWidth / 7) + (collisions * (viewWidth / 28)), startTime * (viewHeight / 24), 10.0, 10.0, 90.0, 90.0);
                roundRectPath.lineTo(counter * (viewWidth / 7)  + (collisions * (viewWidth / 28)), startTime * (viewHeight / 24) + (duration * viewHeight / 24) - 5.0);
                roundRectPath.arcTo(counter * (viewWidth / 7) + (collisions * (viewWidth / 28)), startTime * (viewHeight / 24) + (duration * viewHeight / 24) - 10.0, 10.0, 10.0, 180.0, 90.0);
                roundRectPath.lineTo(counter * (viewWidth / 7) + (viewWidth / 7) - 5.0, startTime * (viewHeight / 24) + (duration * viewHeight / 24));
                roundRectPath.arcTo(counter * (viewWidth / 7) + (viewWidth / 7) - 10, startTime * (viewHeight / 24) + (duration * viewHeight / 24) - 10.0, 10.0, 10.0, 270.0, 90.0);
                roundRectPath.closeSubpath();

                // Add event to scene.
                if (collisions == 0)
                {
                    graphicsPathItem = this.scene.addPath(roundRectPath, new QPen(), new QBrush(new QColor("goldenrod")));
                }
                else if (collisions == 1)
                {
                    graphicsPathItem = this.scene.addPath(roundRectPath, new QPen(), new QBrush(new QColor("darkorange")));
                }
                else if (collisions == 2)
                {
                    graphicsPathItem = this.scene.addPath(roundRectPath, new QPen(), new QBrush(new QColor("orangered")));
                }
                else if (collisions == 3)
                {
                    graphicsPathItem = this.scene.addPath(roundRectPath, new QPen(), new QBrush(new QColor("firebrick")));
                }

                graphicsPathItem.setZValue(this.parent.events[j][0]);
                graphicsPathItem.setFlag(QGraphicsItem.ItemIsSelectable, true);

                graphicsPathItem.setToolTip(this.parent.events[j][4] + " - " + this.parent.events[j][5] + "\n" + this.parent.events[j][2] + "\n" + this.parent.events[j][3] + "\n");

                // Display event topic.
                graphicsTextItem = this.scene.addSimpleText(this.parent.events[j][2].slice(0,15));
                graphicsTextItem.setZValue(this.parent.events[j][0] + 1);
                graphicsTextItem.setPos(counter * (viewWidth / 7) + 3.0 + (collisions * (viewWidth / 28)), startTime * (viewHeight / 24) + 5.0);

                zCounter += 2;
            }
        }

        // Save the date in table header.
        horizontalHeaders.push(tr(newDate.getDate() + "." + newDate.getKuukausi()));

        // Mark the current day with bold text.
        if (newDate.getDate() == currentDate.getDate() && newDate.getMonth() == currentDate.getMonth()
            && newDate.getFullYear() == currentDate.getFullYear())
        {
            tableItem = this.table.horizontalHeaderItem(counter);
            tableItem.setFont(strongFont);
        }
        else
        {
            tableItem = this.table.horizontalHeaderItem(counter);
            tableItem.setFont(new QFont());
        }


        newDate.setDate(newDate.getDate()+1);
        counter++;
    }

    // Draw lines between days.
    counter = 0;
    while (counter <= 6)
    {
        this.scene.addLine(counter * (viewWidth / 7), 0, counter * (viewWidth / 7), viewHeight - 5, new QPen(new QColor("white")));
        counter++;
    }

    // Display weekdays in table header.
    this.table.setHorizontalHeaderLabels(horizontalHeaders);

    this.update();
}


eventDialog.prototype = new QWidget();

/* Event dialog lists all the events for the selected day. */
function eventDialog(parent, eDate, events)
{
    QWidget.call(this, parent);

    this.eDialog = new QDialog(this);
    this.eDialog.windowTitle = tr(eDate.toDateString());
    this.dialogLayout = new QGridLayout(this.eDialog);

    this.closeButton = new QPushButton(tr("Close"));
    this.deleteButton = new QPushButton(tr("Delete Event"));
    this.submitButton = new QPushButton(tr("Add Event"));

    this.eventDate = eDate;
    this.dbDate = eDate.getFullYear() + '_' + eDate.getKuukausi() + '_' + eDate.getDate();
    this.dayEvents = [];
    var eventCounter = 0;

    this.eTable = new QTableWidget(0,1);
    var horizontalHeaders = new Array(1);
    horizontalHeaders[0]="Events";
    this.eTable.setHorizontalHeaderLabels(horizontalHeaders);
    this.eTable.horizontalHeader().setStyleSheet("background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 0.25, stop: 0 gray, stop: 1 black); color: white;");
    var header = this.eTable.horizontalHeader();
    header.setResizeMode(QHeaderView.Stretch);
    header.setClickable(false);

    var header = this.eTable.verticalHeader();
    header.setVisible(false);

    // Find all the events for the day.
    for (j = 0; j < events.length; j++)
    {
        // Check the date of the event.
        if (events[j][1] == this.dbDate)
        {
            // Save the event.
            this.dayEvents[eventCounter] = [];
            this.dayEvents[eventCounter] = events[j];
            eventCounter++;
        }
    }

    // Update table with events for the day.
    this.updateEventsTable();

    this.eTable["cellActivated(int, int)"].connect(this, this.openEvent);
    this.eTable["currentItemChanged(QTableWidgetItem*, QTableWidgetItem* )"].connect(this, this.selectEvent);
    this.closeButton["clicked()"].connect(this, this.closeButtonClicked);
    this.deleteButton["clicked()"].connect(this, this.deleteButtonClicked);
    this.submitButton["clicked()"].connect(this, this.addEventButtonClicked);

    this.dialogLayout.sizeConstraint = QLayout.SetFixedSize;
    this.dialogLayout.addWidget(this.eTable, 0, 0, 1, -1);
    this.dialogLayout.addWidget(this.closeButton, 1, 0);
    this.dialogLayout.addWidget(this.deleteButton, 1, 1);
    this.dialogLayout.addWidget(this.submitButton, 1, 2);

    this.eDialog.layout = this.dialogLayout;
    this.eDialog.exec();

}

eventDialog.prototype.updateEventsTable = function() {
    var tableItem;
    var iFlags = new Qt.ItemFlags(Qt.ItemIsEnabled);

    // Clear the table.
    this.eTable.clearContents();
    while (this.eTable.rowCount > 0)
    {
        this.eTable.removeRow(this.eTable.rowCount - 1);
    }

    // Go through all the events for the day.
    for (j = 0; j < this.dayEvents.length; j++)
    {
        // Add a new row for the event.
        this.eTable.insertRow(this.eTable.rowCount);

        // Add the event in the table.
        tableItem = new QTableWidgetItem(tr(this.dayEvents[j][4] + "-" + this.dayEvents[j][5] + " " + this.dayEvents[j][2]));
        tableItem.setFlags(iFlags);
        this.eTable.setItem(this.eTable.rowCount - 1, 0, tableItem);
    }

    // If there are no events, display a note.
    if (this.dayEvents.length == 0)
    {
        this.eTable.insertRow(this.eTable.rowCount);
        tableItem = new QTableWidgetItem(tr("No events..."));
        tableItem.setFlags(0);
        this.eTable.setItem(this.eTable.rowCount - 1, 0, tableItem);
        this.deleteButton.setEnabled(false);
    }
}

eventDialog.prototype.selectEvent = function( currentItem, previousItem) {
    var brush_orange = new QBrush(new QColor("orange"));
    var brush_default = new QBrush();

    // Paint the background of the selected item orange.
    if (currentItem != null)
    {
        currentItem.setBackground(brush_orange);
        this.deleteButton.setEnabled(true);
    }

    // Clear the background color from the previous item.
    if (previousItem != null)
    {
        previousItem.setBackground(brush_default);
        this.deleteButton.setEnabled(true);
    }

    // If both are null, disable the delete button.
    if (currentItem == null && previousItem != null)
    {
        this.deleteButton.setEnabled(false);
    }
}

eventDialog.prototype.openEvent = function(selectedRow, selectedColumn) {
    
    // Display a dialog for modifying the selected event.
    this.modifyDialog = new modifyDialog(this, this.eventDate, this.dayEvents[selectedRow]);

    // Create a query to update the events for the day.
    var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/[?eventDate="' + this.dbDate + '"][/startTime]';
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this, this.updateEvents);
    accessManager.get(new QNetworkRequest(new QUrl(url)));
}

eventDialog.prototype.addEventButtonClicked = function() {

    // Display a dialog for creating a new event.
    this.modifyDialog = new modifyDialog(this, this.eventDate, "");

    // Create a query to update the events for the day.
    var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/[?eventDate="' + this.dbDate + '"][/startTime]';
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this, this.updateEvents);
    accessManager.get(new QNetworkRequest(new QUrl(url)));
}

eventDialog.prototype.deleteButtonClicked = function() {

    var msgBox;
    var ret;

    // If no events is selected, do nothing.
    if (this.eTable.currentItem() == null)
    {
        return;
    }

    // Display a confirmation pop-up.
    msgBox = new QMessageBox();
    msgBox.setWindowTitle("Delete event");
    msgBox.text = "Are you sure you want to delete this event? (delete works only with Qt 4.6 or higher)";
    msgBox.addButton("No", QMessageBox.NoRole);
    msgBox.addButton("Yes", QMessageBox.YesRole);

    ret = msgBox.exec();

    // TODO: delete works only with Qt 4.6.
    if (ret == QMessageBox.YesRole)
    {
        // Create a query to delete the selected event.
        var url = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/' + this.dayEvents[this.eTable.currentRow()][0];
        var accessManager = new QNetworkAccessManager(this);
        accessManager["finished(QNetworkReply*)"].connect(this, this.updateEventsTable);
    //    accessManager.deleteResource(new QNetworkRequest(new QUrl(url)));

        // Delete the event from the events-list.
        this.dayEvents.splice(this.eTable.currentRow(), 1);
    }
    
}

eventDialog.prototype.closeButtonClicked = function() {
    this.eDialog.close();
}

eventDialog.prototype.updateEvents = function(reply) {
    var eventsJSONString = reply.readAll().toString();
    var eventsJSONObject = eval('(' + eventsJSONString + ')'); 
    // If there is an error in the JSON or there are no events in the db, 
    // mark events as zero.
    if(eventsJSONObject.error || eventsJSONObject.length == 0)
    {
        this.dayEvents = [];
    }
    else
    {
        // Save all the events for the selected day.
        this.dayEvents = [];
        for (i = 0; i < eventsJSONObject.length; i++)
        {
            this.dayEvents[i] = [];
            this.dayEvents[i][0] = eventsJSONObject[i].id;
            this.dayEvents[i][1] = eventsJSONObject[i].eventDate;
            this.dayEvents[i][2] = eventsJSONObject[i].topic;
            this.dayEvents[i][3] = eventsJSONObject[i].place;
            this.dayEvents[i][4] = eventsJSONObject[i].startTime;
            this.dayEvents[i][5] = eventsJSONObject[i].endTime;
            this.dayEvents[i][6] = eventsJSONObject[i].recurrence;
        }
    }

    // Refresh the calendar.
    this.updateEventsTable(); 
}

modifyDialog.prototype = new QWidget();

/* Modify dialog allows user to either create a new event or modify an existing one. */
function modifyDialog(parent, eDate, event)
{
    QWidget.call(this, parent);

    this.id = "";
    this.dbDate = eDate.getFullYear() + '_' + eDate.getKuukausi() + '_' + eDate.getDate();

    this.setStyleSheet("QLabel {background-color: transparent}");

    this.dialog = new QDialog(this);
    this.dialog.windowTitle = tr("Add Event");

    this.topicLabel = new QLabel(tr("Topic:"));
    this.topic = new QLineEdit;
    this.topic.setStyleSheet("background-color: black");
    this.placeLabel = new QLabel(tr("Place:"));
    this.place = new QLineEdit;
    this.place.setStyleSheet("background-color: black");

    this.dateLabel = new QLabel(tr("Date:"));
    this.dateEdit = new QDateTimeEdit;
    this.dateEdit.setStyleSheet("background-color: black");
    this.dateEdit.setDateRange(Date(1753, 1, 1), Date(8000, 1, 1));    
    this.dateEdit.setDate(eDate);
    this.dateEdit.displayFormat = "dd.MM.yyyy";

    this.startTimeLabel = new QLabel(tr("Starting time:"));
    this.startTime = new QTimeEdit;
    this.startTime.setStyleSheet("background-color: black");
    this.startTime.setTime(new QTime(12, 0));
    this.startTime.displayFormat = "hh:mm";

    this.endTimeLabel = new QLabel(tr("Ending time:"));
    this.endTime = new QTimeEdit;
    this.endTime.setStyleSheet("background-color: black");
    this.endTime.setTime(new QTime(13, 0));
    this.endTime.displayFormat = "hh:mm";

    this.cancelButton = new QPushButton(tr("Cancel"));
    this.submitButton = new QPushButton(tr("Submit"));

/*    this.recurrenceLabel = new QLabel(tr("Recurrence:"));
    this.recurrenceCombo = new QComboBox;
    this.recurrenceCombo.setStyleSheet("background-color: black");
    this.recurrenceCombo.addItem("Once");
    this.recurrenceCombo.addItem("Daily");
    this.recurrenceCombo.addItem("Working days");
    this.recurrenceCombo.addItem("Weekly");
    this.recurrenceCombo.addItem("Every 2 weeks");
    this.recurrenceCombo.addItem("Monthly");
    this.recurrenceCombo.addItem("Yearly");
    this.recurrenceCombo.maxVisibleItems = 7;*/

    this.extension = new QWidget();
    this.extensionLayout = new QVBoxLayout();

    // Check if we are updating an event.
    if (event != "")
    {
        // Event found. Save the data.
        this.id = event[0];
        this.topic.setText(event[2]);
        this.place.setText(event[3]);
        timeObject = QTime.fromString(event[4], "hh:mm");
        this.startTime.setTime(timeObject);
        timeObject = QTime.fromString(event[5], "hh:mm");
        this.endTime.setTime(timeObject);
        //this.recurrenceCombo.setCurrentIndex(event[6]);
            
        this.dialog.windowTitle = tr("Modify Event");
    }

    this.cancelButton["clicked()"].connect(this, this.cancelButtonClicked);
    this.submitButton["clicked()"].connect(this, this.submitButtonClicked);

    this.dialogLayout = new QGridLayout(this.dialog);
    this.dialogLayout.sizeConstraint = QLayout.SetFixedSize;
    this.dialogLayout.addWidget(this.topicLabel, 0, 0);
    this.dialogLayout.addWidget(this.topic, 0, 1);
    this.dialogLayout.addWidget(this.placeLabel, 1, 0);
    this.dialogLayout.addWidget(this.place, 1, 1);
    this.dialogLayout.addWidget(this.dateLabel, 2, 0);
    this.dialogLayout.addWidget(this.dateEdit, 2, 1);
    this.dialogLayout.addWidget(this.startTimeLabel, 3, 0);
    this.dialogLayout.addWidget(this.startTime, 3, 1);
    this.dialogLayout.addWidget(this.endTimeLabel, 4, 0);
    this.dialogLayout.addWidget(this.endTime, 4, 1);
//    this.dialogLayout.addWidget(this.recurrenceLabel, 5, 0);
//    this.dialogLayout.addWidget(this.recurrenceCombo, 5, 1);
    this.dialogLayout.addWidget(this.cancelButton, 6, 0);
    this.dialogLayout.addWidget(this.submitButton, 6, 1);

    // Hide the recurrent options.
    this.extension.hide();

    this.dialog.layout = this.dialogLayout;
    this.dialog.exec();
}

modifyDialog.prototype.cancelButtonClicked = function() {
    this.dialog.close();
}

modifyDialog.prototype.submitButtonClicked = function() {

    var baseStr = 'http://lively.cs.tut.fi:8010/SimpleCalendarEvent/' + this.id;
    var saveTime = this.dateEdit.dateTime.getFullYear() + '_' + (this.dateEdit.dateTime.getMonth() + 1) + '_' + this.dateEdit.dateTime.getDate();
    
    var jsonStr = '{"eventDate":"' +saveTime + '","topic":"' +this.topic.text +'","place":"' +this.place.text +'","startTime":"' +this.startTime.text +'","endTime":"' +this.endTime.text +'","recurrence":"0"}';
    var jsonArr = new QByteArray(jsonStr);
    var req = new QNetworkRequest(new QUrl(baseStr));

    // QNetworkAccessManager for network requests
    var accessManager = new QNetworkAccessManager(this);
    accessManager["finished(QNetworkReply*)"].connect(this, this.saveEvent);
    
    if (this.id == "")
    {
        // Send the HTTP/POST request to create a new event-object.
        accessManager.post(req, jsonArr);
    }
    else
    {
        // Send the HTTP/PUT request to update the existing event-object.
        accessManager.put(req, jsonArr);
    }

    this.dialog.close();

}

modifyDialog.prototype.saveEvent = function(reply) {
    var data = reply.readAll().toString();
    print(data);
}


// Returns the contents of QByteArray as a string
QByteArray.prototype.toString = function() {
   ts = new QTextStream( this, QIODevice.ReadOnly );
   return ts.readAll();
};

/* To use the application in standalone mode, remove the comment around this code 
var wdgt = new QtProjectCalendar();
wdgt.show();

QCoreApplication.exec();
*/

