/*========================================================================
 * Copyright (c) 2009 Tampere University of Technology, Finland
 * 
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *======================================================================*/

// Twitter location updating client

function tr(s) { return s; }

function QtTwitterLocation(parent)
{
    QWidget.call(this, parent);

	this.MY_API_KEY = "ABQIAAAAjfRjTDOGscFuDUwMxJYaQRQUpi_xkJDYa0W0Jatk4awxKuvp7BQBfOyxYXrIsE8mc8pdYrHlaNjZjQ";

    this.windowTitle = tr("QtTwitterLatitude: Twitter Location Updater");
    
	this.map = new QPixmap();

	this.username = new QLineEdit("webmodemo",this);
	this.passwd = new QLineEdit("webmodemo33720",this);
	this.passwd.echoMode = QLineEdit.Password;
	this.passwd.returnPressed.connect(this,this.updateTwitterLoc);
	
	this.status = new QLabel(this);
	this.status.wordWrap = true;
	
	this.updateLocBtn = new QPushButton("Update my Twitter profile location", this);
	this.updateLocBtn.clicked.connect(this, this.updateTwitterLoc);
	
	this.layout = new QFormLayout(this);
	this.layout.addRow("<b>Username:</b>", this.username);
	this.layout.addRow("<b>Password:</b>", this.passwd);
	this.layout.addRow("", this.updateLocBtn);
	this.layout.addRow("",this.status);

	/*this.timer = new QTimer(this);
	this.timer["timeout()"].connect(this, this.getLocationInformation);
	this.timer.start(5000);*/

	this.place = {};
	
    this.resize(300,350);
	this.setDisabled(true);
	
	this.getLocationInformation();
	
}

QtTwitterLocation.prototype = new QWidget();

QtTwitterLocation.prototype.updateTwitterLoc = function() {
	if(this.username.text.length === 0 || this.passwd.text.lenght === 0) {
		return;
	}
	
	var auth = new QByteArray(this.username.text + ":" + this.passwd.text);
	auth = new QByteArray("Basic " + auth.toBase64().toString());
	var location = new QByteArray("location="+this.place.city+",+"+this.place.country);

	var url = "http://twitter.com/account/update_profile.json";
	
	var request = new QNetworkRequest(new QUrl(url));
	request.setRawHeader(new QByteArray("Authorization"), auth);
	
	print(auth.toBase64().toString());
	
	var accessManager = new QNetworkAccessManager(this);
	accessManager.post(request,location);
	accessManager["finished(QNetworkReply*)"].connect(this, this.updateTwitterLocFinished);
};

QtTwitterLocation.prototype.updateTwitterLocFinished = function(reply) {
	//print(reply.attribute(QNetworkRequest.HttpStatusCodeAttribute));
	var trendJSONString = reply.readAll().toString();
	var trendJSONObject = eval('(' + trendJSONString + ')');
	if(trendJSONObject.error) {
		this.status.text = "<h3>" + trendJSONObject.error + "</h3>";
		return;
	}
	if(trendJSONObject.location) {
		this.status.text = "<center><font color=white><h1>Thanks " + trendJSONObject.screen_name + "!</h1>" +
							":)<h4>Your location is now </h4><h2>" + trendJSONObject.location + "</h2><br>" + 
							"<h4>Your current status is:</h4><h2>" + trendJSONObject.status.text + "</h2><br><br>";
	}
	this.username.hide();
	this.layout.labelForField(this.username).hide();
	this.passwd.hide();
	this.layout.labelForField(this.passwd).hide();
	this.updateLocBtn.hide();
	this.styleSheet = "QLabel { background-color: rgba(49,100,199,60%); } ";
};

QtTwitterLocation.prototype.locLoadFinished = function(reply) {
	var stream = new QTextStream(reply.readAll(), QIODevice.ReadOnly);
	while(!stream.atEnd()) {
		var line = stream.readLine();
		if(line.indexOf("Country: ") !== -1) {
			this.place.country = line.substr(9,line.length-1);
		}
		if(line.indexOf("City: ") !== -1) {
			this.place.city = line.substr(6,line.length-1);
		}
		if(line.indexOf("Latitude: ") !== -1) {
			this.place.lat = line.substr(10,line.length-1);
		}
		if(line.indexOf("Longitude: ") !== -1) {
			this.place.lng = line.substr(11,line.length-1);
		}
	}
	if(this.place.country) {
		this.status.text = "Your location is: <b>" + this.place.city +", " + this.place.country + "</b>";
		this.getGoogleMapsImage(this.place.lat, this.place.lng);
	}
	else {
		this.status.text = "<b>Your location can not be defined</b>";
	}
};

QtTwitterLocation.prototype.getLocationInformation = function() {
	var url = "http://api.hostip.info/get_html.php?position=true";
	var accessManager = new QNetworkAccessManager(this);
	accessManager["finished(QNetworkReply*)"].connect(this, this.locLoadFinished);
	accessManager.get(new QNetworkRequest(new QUrl(url)));
};

QtTwitterLocation.prototype.getGoogleMapsImage = function(lat,lng) {
	var width = this.width;
	var height = this.height;
	if(width > 640) {
		width = 640;
	}
	if(height > 640) {
		height = 640;
	}
		
	var url = 'http://maps.google.com/staticmap?center=' +lat+','+lng+
		'&zoom=13&size='+width+'x'+height+'&maptype=mobile&'+'markers=' +lat+','+lng +
		'&sensor=false&key=' + this.MY_API_KEY;
	var accessManager = new QNetworkAccessManager(this);
	accessManager["finished(QNetworkReply*)"].connect(this, this.mapLoadFinished);
	accessManager.get(new QNetworkRequest(new QUrl(url)));
};

QtTwitterLocation.prototype.mapLoadFinished = function(reply) {
	var data = reply.readAll();
	this.map.loadFromData(data, Qt.AutoColor);
	this.update();
	this.setEnabled(true);
};

QtTwitterLocation.prototype.paintEvent = function (event) {
	var painter = new QPainter();
	painter.begin(this);
	if(!this.map.isNull()) {
		painter.drawPixmap(0,0,this.map.scaled(this.width,this.height,Qt.KeepAspectRatioByExpanding,Qt.SmoothTransformation));	
	}
	painter.end();
};

QByteArray.prototype.toString = function()
{
   ts = new QTextStream( this, QIODevice.ReadOnly );
   return ts.readAll();
};

/* To use the application in standalone mode, remove the comment around this code 

var wdgt = new QtTwitterLocation();
wdgt.show();

QCoreApplication.exec();*/

