/*========================================================================
 * Copyright (c) 2009 Tampere University of Technology, Finland
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *======================================================================*/

function Fileloader()
{
    this.accessmanager = new QNetworkAccessManager();
}

Fileloader.prototype.loadFiles = function(files, caller, callback)
{
    var current = files.pop();
    req_reply = this.accessmanager.get(new QNetworkRequest(new QUrl(current)));
    function fileLoaded()
    {
        // Read data and inform callback function about this
        var data = req_reply.readAll();
        var filegroup = { files_left: files.length };
        callback(caller, current, data, filegroup);
        // Start loading new file if there are any left.
        if (files.length > 0) {
            this.loadFiles(files, caller, callback);
        }
    }
    req_reply.finished.connect(this, fileLoaded);
}

